Mesh FromPartShape: Difference between revisions

From FreeCAD Documentation
m (Renatorivo moved page Mesh MeshFromShape to Mesh FromPartShape without leaving a redirect: Part of translatable page "Mesh MeshFromShape")
m ((Vertical Docnav)(Vertical GuiCommand))
Line 2: Line 2:
<translate>
<translate>
<!--T:1-->
<!--T:1-->
{{Docnav
{{Docnav|[[Mesh Export|Export Mesh]]|[[Mesh CurvaturePlot|Curvature Plot]]|[[Mesh_Workbench|Mesh]]|IconL=Mesh_ExportMesh.png|IconC=Workbench_Mesh.svg|IconR=Mesh_CurvaturePlot.png}}
|[[Mesh Export|Export Mesh]]
|[[Mesh CurvaturePlot|Curvature Plot]]
|[[Mesh_Workbench|Mesh]]
|IconL=Mesh_ExportMesh.png
|IconC=Workbench_Mesh.svg
|IconR=Mesh_CurvaturePlot.png
}}


<!--T:2-->
<!--T:2-->
{{GuiCommand
{{GuiCommand|Name=Mesh MeshFromShape‏‎|MenuLocation=Meshes → Create Mesh from Shape|Workbenches=[[Mesh Workbench|Mesh]]|SeeAlso=}}
|Name=Mesh MeshFromShape‏‎
|MenuLocation=Meshes → Create Mesh from Shape
|Workbenches=[[Mesh Workbench|Mesh]]
|SeeAlso=
}}


==Introduction== <!--T:3-->
==Introduction== <!--T:3-->
Line 14: Line 26:
<!--T:5-->
<!--T:5-->
There are two methods:
There are two methods:
# Either select the shape object, then choose {{KEY| Meshes}} → {{KEY|[[Image:Mesh_Mesh_from_Shape.svg|32px]] Create Mesh from shape...}} from the top menu.
# Either select the shape object, then choose {{KEY|Meshes}} → {{KEY|[[Image:Mesh_Mesh_from_Shape.svg|32px]] Create Mesh from shape...}} from the top menu.
# Just selecting {{KEY| Meshes}} → {{KEY|[[Image:Mesh_Mesh_from_Shape.svg|32px]] Create Mesh from shape...}} will give you an additional menu to choose your shape to mesh.
# Just selecting {{KEY| Meshes}} → {{KEY|[[Image:Mesh_Mesh_from_Shape.svg|32px]] Create Mesh from shape...}} will give you an additional menu to choose your shape to mesh.


Line 76: Line 88:
<!--T:20-->
<!--T:20-->
This tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:
This tool can be used in [[macros|macros]] and from the [[Python|Python]] console by using the following function:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 84: Line 97:
<!--T:21-->
<!--T:21-->
Example:
Example:

</translate>
</translate>
{{Code|code=
{{Code|code=
Line 105: Line 119:


<!--T:23-->
<!--T:23-->
{{Docnav
{{Docnav|[[Mesh Export|Export Mesh]]|[[Mesh CurvaturePlot|Curvature Plot]]|[[Mesh_Workbench|Mesh]]|IconL=Mesh_ExportMesh.png|IconC=Workbench_Mesh.svg|IconR=Mesh_CurvaturePlot.png}}
|[[Mesh Export|Export Mesh]]
|[[Mesh CurvaturePlot|Curvature Plot]]
|[[Mesh_Workbench|Mesh]]
|IconL=Mesh_ExportMesh.png
|IconC=Workbench_Mesh.svg
|IconR=Mesh_CurvaturePlot.png
}}


<!--T:24-->
<!--T:24-->

Revision as of 09:55, 30 October 2019

Mesh MeshFromShape‏‎

Menu location
Meshes → Create Mesh from Shape
Workbenches
Mesh
Default shortcut
None
Introduced in version
-
See also
None

Introduction

This command creates a mesh from a shape object.

Usage

There are two methods:

  1. Either select the shape object, then choose Meshes Create Mesh from shape... from the top menu.
  2. Just selecting Meshes Create Mesh from shape... will give you an additional menu to choose your shape to mesh.

In both cases you get a menu that asks for the mesher program to use and its settings.
The settings you make there will be stored and used as default for the next time you create a mesh from a shape. introduced in version 0.19.

Mesher program

You can choose one of these 3 mesher programs:

Standard Mesher

You can change these settings:

  • Surface deviation: Maximal linear deflection of a mesh section from the surface of the object
  • Angular deviation: Maximal angular deflection from one mesh section to the next section
  • Relative surface deviation: If checked, the maximal linear deviation of a mesh segment will be the specified Surface deviation multiplied by the length of the current mesh segment (edge)
  • Apply face colors to mesh: If checked, the mesh will get the face colors of the object
  • Define segments by face colors: If checked, mesh segments will be grouped according to the color of the object faces. These groups will be exported for mesh output formats supporting this feature (e.g. the format OBJ).

Mefisto Mesher

The only setting is:

  • Maximum edge length: If this number is smaller the mesh becomes finer. The smallest value is 0.

Netgen Mesher

You can choose between mesh Fineness being:

  • Very coarse
  • Coarse
  • Moderate
  • Fine
  • Very fine
  • User defined
For this you can set these values:
Mesh size grading: If this parameter is smaller, the mesh becomes finer. A value in the range of 0.1-1.
Element per edge: If this parameter is larger, the mesh becomes finer. A value in the range of 0.2-10.
Element per curvature radius: If this parameter is larger, the mesh becomes finer. A value in the range of 0.2-10.

For every Fineness you can also choose:

  • Optimize surface: Whether an optimization of surface shape will be done.
  • Second order elements: Whether second order elements will be generated.
  • Quad dominated: Whether meshes will be arranged preferably using quadrilateral faces.

Scripting

This tool can be used in macros and from the Python console by using the following function:

MeshPart.meshFromShape(Shape=Shape, MaxLength=520)

Example:

import FreeCAD, Draft, Arch, Mesh, MeshPart

Line = Draft.makeWire([FreeCAD.Vector(0, 0, 0),FreeCAD.Vector(2000, 2000, 0)])
Wall = Arch.makeWall(Line, width=150, height=3000)
FreeCAD.ActiveDocument.recompute()

Shape = Wall.Shape.copy(False)
Shape.Placement = Wall.getGlobalPlacement()

mesh_obj = FreeCAD.ActiveDocument.addObject("Mesh::Feature", "Mesh")
mesh_obj.Mesh = MeshPart.meshFromShape(Shape=Shape, MaxLength=520)
mesh_obj.ViewObject.DisplayMode = "Flat Lines"

Notes